#include <STC8H.H>
#include <intrins.h>
#include <absacc.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include <math.h>
	
#define		FOSC			24000000UL					//ʱ
#define		BAUD			9600UL						//
#define		BRT				(0x10000-(FOSC/BAUD+2)/4)	//ֵ
#define		T_Buf_Len		64							//Uart1ͻ泤
#define		R_Buf_Len		64							//Uart1ջ泤

unsigned char		RP;					//Uart1ָ
unsigned char		TP;					//Uart1ָ
unsigned char		Uart_R_Len;			//Uart1ճ
unsigned char		Uart_T_Len;			//Uart1ͳ
unsigned char xdata	R_Buf[R_Buf_Len];	//Uart1ջ
unsigned char xdata	T_Buf[T_Buf_Len];	//Uart1ͻ

void Delay_ms(unsigned char ms)
{
	unsigned int i;
	do
	{
		i=FOSC/10000;
		while(--i);	//10T per loop
	}
	while(--ms);
}

void UART_Send(unsigned int x)
{
	while(Uart_T_Len);
	TP=0;
	Uart_T_Len=x;
	TI=1;
}

void Init(void)
{
	P_SW2|=EAXFR;
	
	P0M1=0x00;	P0M0=0x00;	//Ϊ׼˫
	P1M1=0x00;	P1M0=0x00;	//Ϊ׼˫
	P2M1=0x00;	P2M0=0x00;	//Ϊ׼˫
	P3M1=0x00;	P3M0=0x00;	//Ϊ׼˫
	P4M1=0x00;	P4M0=0x00;	//Ϊ׼˫
	P5M1=0x00;	P5M0=0x00;	//Ϊ׼˫
	P6M1=0x00;	P6M0=0x00;	//Ϊ׼˫
	P7M1=0x00;	P7M0=0x00;	//Ϊ׼˫
	
	AUXR=0x05;		//öʱ2Ϊ1Tģʽöʱ2Ϊʷ
	SCON=0x50;		//UART1ģʽΪ8λݿɱ䲨
	T2H=BRT>>8;		//UART1
	T2L=BRT;		//UART1
	AUXR|=T2R;		//򿪶ʱ2
	ES=1;			//UART1ж
	
	EA=1;			//ж
}

void main(void)
{
	Init();
	while(1)
	{
		
	}
}

void UART1_Isr(void) interrupt UART1_VECTOR
{
	if(RI)
	{
		RI=0;
		R_Buf[RP]=SBUF;
		RP++;
		if(RP==1)
		{
			if(R_Buf[0]=='a')
			{
				T_Buf[0]='b';
				UART_Send(1);
				RP=0;
			}
		}
	}
	if(TI)
	{
		TI=0;
		if(TP==Uart_T_Len)
		{
			TP=0;
			Uart_T_Len=0;
		}
		if(Uart_T_Len!=0)
		{
			SBUF=(T_Buf[TP]);
			TP++;
		}
	}
}